/* ----------------------------------------------------------------
 *
 * utils.h
 * 
 * Christoph C. Birk (birk@obs.carnegiescience.edu)
 *
 * ---------------------------------------------------------------- */

#ifndef INCLUDE_UTILS_H
#define INCLUDE_UTILS_H

/* ---------------------------------------------------------------- */

#include <time.h>                      // time_t

/* GLOBALs -------------------------------------------------------- */

#ifndef RADS
#define RADS          (180.0/M_PI)
#endif

#ifndef PREFUN
#define PREFUN        __func__
#endif

/* ---------------------------------------------------------------- */

double get_sidereal   (time_t,double);
double get_st         (time_t,double);
double get_airmass    (double,double,double);
double get_ha         (time_t,double,double);
double get_epoch      (time_t);
char*  get_night      (char*,time_t);
int    get_uts        (time_t);
time_t cor_time       (long);
double walltime       (void);

char*  time_str       (char*,double);
char*  alpha_str      (char*,double);
char*  delta_str      (char*,double);
double d_alpha        (const char*);
double d_delta        (const char*);
// double d_equinox      (const char*);

void   precess        (double,double,double,double*,double*,double);

void   q_sort         (int*,int,int);
void   f_sort         (float*,int,int);

char*  my_extend          (char*,char,int);
char*  cut_spaces         (char*);

int    imin               (int,int);
int    imax               (int,int);

char*  get_local_datestr  (char*,time_t);
char*  get_local_timestr  (char*,time_t);
char*  get_ut_timestr     (char*,time_t);

double mag2flux           (double,double);
double flux2peak          (double,double,double);
double peak2flux          (double,double);
double flux2mag           (double,double);

int    is_bigendian       (void);

double my_round           (double,int);

double modulo             (double,double,double);
double modneg             (double,double);
double modtop             (double,double);

/* ---------------------------------------------------------------- */

#endif  // INCLUDE_UTILS_H

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
